<?
/***************************************************************************
* @developer Anton Panov, makeshop.pro
* @module ms_filter_with_variations
* @version 1.0.0
* @license GNU GPL 3
****************************************************************************/

use Tygh\Registry;

if (!defined('BOOTSTRAP')) { die('Access denied'); }

function fn_ms_filter_with_variations_get_filters_products_count_pre(&$params)
{
	if (in_array(Registry::get('addons.ms_filter_with_variations.behavior'), ["filter_with_variations", "filter_with_parent_product"]))
		$params['product_type'] = ['C', 'P', 'V'];
	if (in_array(Registry::get('addons.ms_filter_with_variations.behavior'), ["filter_only_variations"]))
		$params['product_type'] = ['V'];
}

function fn_ms_filter_with_variations_get_products_before_select(&$params, $join, $condition, $u_condition, $inventory_join_cond, $sortings, $total, $items_per_page, $lang_code, $having)
{
	$afilter_only=Registry::get('addons.ms_filter_with_variations.filter_only');
	if (in_array(Registry::get('addons.ms_filter_with_variations.behavior'), ["filter_with_variations", "filter_only_variations"])) {
		$aDisallowed = explode(",", Registry::get('addons.ms_filter_with_variations.disallowed'));

		if (!in_array($params['dispatch'], $aDisallowed) && $params['items_per_page']>0 && (($params['features_hash']!='' && $afilter_only=='Y') || $afilter_only=='N') ) {
			if (in_array(Registry::get('addons.ms_filter_with_variations.behavior'), ["filter_only_variations"]))
				$params['product_type'] = ['V'];
			else
				$params['product_type'] = ['C', 'P', 'V'];
		}
	
	}
}

function fn_ms_filter_with_variations_get_products($params, $fields, $sortings, &$condition, &$join, $sorting, $group_by, $lang_code, $having)
{
	$afilter_only=Registry::get('addons.ms_filter_with_variations.filter_only');
	if (Registry::get('addons.ms_filter_with_variations.behavior')=="filter_with_parent_product") {
		$aDisallowed = explode(",", Registry::get('addons.ms_filter_with_variations.disallowed'));

		if (!in_array($params['dispatch'], $aDisallowed) && $params['items_per_page']>0 && (($params['features_hash']!='' && $afilter_only=='Y') || $afilter_only=='N') ) {
			$sJoin = str_replace("products.", "p.", $join);
			$sCondition = str_replace("products.", "p.", $condition);
			
			$sJoin = preg_replace("/INNER JOIN \?:products_categories.*?(?=INNER)/", "", $sJoin);
			$sJoin = preg_replace("/INNER JOIN \?:categories.*?(?=LEFT)/", "", $sJoin);
			$sJoin = preg_replace("/INNER JOIN \?:categories.*?$/", "", $sJoin);
			
			preg_match("/AND \?:categories.*?(?=AND)/", $sCondition, $aMatches);
			$sCategoriesCondition = $aMatches[0];
			
			$sCondition = preg_replace("/AND \?:categories.*?(?=AND)/", "", $sCondition);
			$sCondition = preg_replace("/AND p\.product_type.*\)/", "", $sCondition);
			
			$sOrCondition = "SELECT COUNT(*) FROM ?:products AS p $sJoin WHERE p.parent_product_id=products.product_id $sCondition";
			
			$condition = preg_replace(
				"/^\s*AND\s*(.*)/", 
				"AND (\\1) OR (($sOrCondition)>0 AND products.status IN ('A') $sCategoriesCondition)", 
				$condition
			);
			
		}
	}

}
